/***********
 * CDLOGCompSeqDirector.h.h
 *
 * 
 *
 *
 *********/
 
#define _H_CDLOGCompSeq /* Include this File only once */
#include "CDLOGDirector.h"
 
class CDLOGCompSeqDirector : public CDLOGDirector 
{
	public:
		void SelectRadioButtons( void);
		void IDLOGCompSeqDirector( short DLOGid, CDirectorOwner *aSupervisor);
		void HandleDialog(SFReply *reply, int *CompilationError);
		void DowmLoad(void);

};

typedef struct
{
	QElem		queue;
	NMRec		notify;
	FSSpec		file;
	short		hour;
	short		minute;
	Boolean		launch;
	Str255		alert;
	Str255		menuString;
	short		menuItem;
	Boolean		dispose;
	Boolean 	wasPosted;
}	SEQCompRec, *SEQCompPtr;

//void		    CompileSequence(SFReply *reply, int *CompilationError);
void 			CopyDialogToSEQComp( DialogPtr  dialog, 
                                     SEQCompPtr sEQComp, 
                                     SFReply 	*reply,
                                     short		*CompilationError);
void		 	DoError(Str255	errorString, Boolean fatal);
void 			HandleDialog(SFReply *reply, short *CompilationError);
void 			DowmLoad(void);

