#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <StandardFile.h>
#include <setjmp.h>
#include <stdlib.h>
#include <math.h>
#include "seq.h"
#include "download.h"
#include "CDLOGCompSeqDirector.h"

#define kNilFilterProc    	nil
#define kEmptyString	  	"\p"
#define kBaseResID	 	  	128	
#define kErrorAlertID	  	kBaseResID+3	
#define kMoveToFront      (WindowPtr)-1L	

#define kOn				  1
#define kOff			  0

#define kAlpha				20
#define kHex				21
#define kBin				22

#define	kVMEAddressDLOGID	3002

#define	kVMEAddress			3
#define	kFileName			6

void DownLoad(void)
{
	static FILE 			*fp;
	static FILE 			*fi;
	static jmp_buf			env;
	SFReply 				myreply,*reply;
	
	reply = &myreply;
	
	GetFileName(reply);
	
	if(reply->good == 1)
	{
		if ((fi = fopen(p2cstr(reply->fName),"r")) == NULL)	
		{
			SeqDoError("\pCan't open Read File...",true, env);
		}
		
		c2pstr((char *) reply->fName);
		
		VMEAddressDialog(reply);
	}
	else
		return;
	
}
/************ VMEAddressDialog *******/

void		VMEAddressDialog(SFReply *reply)
{
	DialogPtr				dialog;
	Boolean					dialogDone = false;
	short					itemHit, itemType;
	Handle					itemHandle;
	Handle					okItemHandle;
	Rect					itemRect;
	Str255					itemText;
		
	dialog = GetNewDialog(kVMEAddressDLOGID, nil, kMoveToFront );
	
	ShowWindow( dialog );
	SetPort( dialog );
	
	SetDialogDefaultItem(dialog, ok);
	SetDialogCancelItem(dialog, cancel);
		
	GetDItem( dialog, ok, &itemType, &okItemHandle, &itemRect);	
	
	GetDItem( dialog, kVMEAddress, &itemType, &itemHandle, &itemRect);
	SelIText(dialog, kVMEAddress, 0, 8);
			
	GetDItem( dialog, kFileName, &itemType, &itemHandle, &itemRect);
	SetIText(itemHandle, reply->fName);	
		
	while(! dialogDone)
	{
			
		ModalDialog( nil, &itemHit);
		
		switch( itemHit )
		{
			case ok:
			case cancel:
				dialogDone = true;
				break;				
		}
	}
	
	if(itemHit==ok)
	{
		GetDItem(dialog, kVMEAddress,  &itemType, &itemHandle, &itemRect);
		GetIText(itemHandle,itemText);
		
		DoError("\pFeature not yet supported !",false  );
	}
		
	DisposDialog(dialog);
	
}

